import { openBlock as n, createElementBlock as r, createElementVNode as c, normalizeClass as u, Fragment as y, renderList as f, renderSlot as F, withDirectives as S, withModifiers as o, vShow as T, withKeys as g, createCommentVNode as m, toDisplayString as v } from "vue";
const x = (e, t) => {
  const s = e.__vccOpts || e;
  for (const [d, l] of t)
    s[d] = l;
  return s;
}, R = {
  props: {
    elementId: String,
    inputId: String,
    existingTags: {
      type: Array,
      default: () => []
    },
    modelValue: {
      type: Array,
      default: () => []
    },
    idField: {
      type: String,
      default: "key"
    },
    textField: {
      type: String,
      default: "value"
    },
    displayField: {
      type: String,
      default: null
    },
    valueFields: {
      type: String,
      default: null
    },
    disabled: {
      type: Boolean,
      default: !1
    },
    typeahead: {
      type: Boolean,
      default: !1
    },
    typeaheadStyle: {
      type: String,
      default: "badges"
    },
    typeaheadActivationThreshold: {
      type: Number,
      default: 1
    },
    typeaheadMaxResults: {
      type: Number,
      default: 0
    },
    typeaheadAlwaysShow: {
      type: Boolean,
      default: !1
    },
    typeaheadShowOnFocus: {
      type: Boolean,
      default: !0
    },
    typeaheadHideDiscard: {
      type: Boolean,
      default: !1
    },
    typeaheadUrl: {
      type: String,
      default: ""
    },
    typeaheadCallback: {
      type: Function,
      default: null
    },
    placeholder: {
      type: String,
      default: "Add a tag"
    },
    discardSearchText: {
      type: String,
      default: "Discard Search Results"
    },
    limit: {
      type: Number,
      default: 0
    },
    hideInputOnLimit: {
      type: Boolean,
      default: !1
    },
    onlyExistingTags: {
      type: Boolean,
      default: !1
    },
    deleteOnBackspace: {
      type: Boolean,
      default: !0
    },
    allowDuplicates: {
      type: Boolean,
      default: !1
    },
    validate: {
      type: Function,
      default: () => !0
    },
    addTagsOnComma: {
      type: Boolean,
      default: !1
    },
    addTagsOnSpace: {
      type: Boolean,
      default: !1
    },
    addTagsOnBlur: {
      type: Boolean,
      default: !1
    },
    wrapperClass: {
      type: String,
      default: "tags-input-wrapper-default"
    },
    sortSearchResults: {
      type: Boolean,
      default: !0
    },
    caseSensitiveTags: {
      type: Boolean,
      default: !1
    },
    beforeAddingTag: {
      type: Function,
      default: () => !0
    },
    beforeRemovingTag: {
      type: Function,
      default: () => !0
    }
  },
  data() {
    return {
      badgeId: 0,
      tags: [],
      input: "",
      oldInput: "",
      hiddenInput: "",
      searchResults: [],
      searchSelection: 0,
      selectedTag: -1,
      isActive: !1,
      composing: !1
    };
  },
  created() {
    this.typeaheadTags = this.cloneArray(this.existingTags), this.tagsFromValue(), this.typeaheadAlwaysShow && this.searchTag(!1);
  },
  mounted() {
    this.$emit("initialized"), document.addEventListener("click", (e) => {
      e.target !== this.$refs.taginput && this.clearSearchResults();
    });
  },
  computed: {
    hideInputField() {
      return this.hideInputOnLimit && this.limit > 0 && this.tags.length >= this.limit || this.disabled;
    }
  },
  watch: {
    input(e, t) {
      this.searchTag(!1), e.length && e != t && (this.addTagsOnSpace && e.endsWith(" ") && (this.input = e.trim(), this.tagFromInput(!0)), this.addTagsOnComma && (e = e.trim(), e.endsWith(",") && (this.input = e.substring(0, e.length - 1), this.tagFromInput(!0))), this.$emit("change", e));
    },
    existingTags(e) {
      this.typeaheadTags.splice(0), this.typeaheadTags = this.cloneArray(e), this.searchTag();
    },
    "tags.length"() {
      this.hiddenInput = JSON.stringify(this.tags), this.$emit("update:modelValue", this.tags);
    },
    modelValue() {
      this.tagsFromValue();
    },
    typeaheadAlwaysShow(e) {
      e ? this.searchTag(!1) : this.clearSearchResults();
    }
  },
  methods: {
    escapeRegExp(e) {
      return e.replace(/[.*+?^${}()|[\]\\]/g, "\\$&");
    },
    tagFromInput(e = !1) {
      if (!this.composing)
        if (this.searchResults.length && this.searchSelection >= 0 && !e)
          this.tagFromSearch(this.searchResults[this.searchSelection]), this.input = "";
        else {
          let t = this.input.trim();
          if (!this.onlyExistingTags && t.length && this.validate(t)) {
            this.input = "";
            let s = {
              [this.idField]: "",
              [this.textField]: t
            };
            const d = this.escapeRegExp(
              this.caseSensitiveTags ? s[this.textField] : s[this.textField].toLowerCase()
            );
            for (let l of this.typeaheadTags) {
              const a = this.escapeRegExp(
                this.caseSensitiveTags ? l[this.textField] : l[this.textField].toLowerCase()
              );
              if (d === a) {
                s = Object.assign({}, l);
                break;
              }
            }
            this.addTag(s);
          }
        }
    },
    tagFromSearchOnClick(e) {
      this.tagFromSearch(e), this.$refs.taginput.blur();
    },
    tagFromSearch(e) {
      this.clearSearchResults(), this.addTag(e), this.$nextTick(() => {
        this.input = "", this.oldInput = "";
      });
    },
    addTag(e, t = !1) {
      if (!(this.disabled && !t)) {
        if (!this.beforeAddingTag(e))
          return !1;
        if (this.limit > 0 && this.tags.length >= this.limit)
          return this.$emit("limit-reached"), !1;
        this.tagSelected(e) || (this.tags.push(e), this.$nextTick(() => {
          this.$emit("tag-added", e), this.$emit("tags-updated");
        }));
      }
    },
    removeLastTag() {
      !this.input.length && this.deleteOnBackspace && this.tags.length && this.removeTag(this.tags.length - 1);
    },
    removeTag(e) {
      if (this.disabled)
        return;
      let t = this.tags[e];
      if (!this.beforeRemovingTag(t))
        return !1;
      this.tags.splice(e, 1), this.$nextTick(() => {
        this.$emit("tag-removed", t), this.$emit("tags-updated"), this.typeaheadAlwaysShow && this.searchTag();
      });
    },
    searchTag() {
      if (this.typeahead !== !0)
        return !1;
      if (this.oldInput != this.input || !this.searchResults.length && this.typeaheadActivationThreshold == 0 || this.typeaheadAlwaysShow || this.typeaheadShowOnFocus) {
        !this.typeaheadUrl.length && !this.typeaheadCallback && (this.searchResults = []), this.searchSelection = 0;
        let e = this.input.trim();
        if (e.length && e.length >= this.typeaheadActivationThreshold || this.typeaheadActivationThreshold == 0 || this.typeaheadAlwaysShow) {
          const t = this.escapeRegExp(
            this.caseSensitiveTags ? e : e.toLowerCase()
          );
          if (this.typeaheadCallback)
            this.typeaheadCallback(t).then((s) => {
              this.typeaheadTags = s, this.doSearch(t);
            });
          else if (this.typeaheadUrl.length > 0) {
            this.typeaheadTags.splice(0);
            const s = new XMLHttpRequest(), d = this;
            s.onreadystatechange = function() {
              this.readyState == 4 && this.status == 200 && (d.typeaheadTags = JSON.parse(s.responseText), d.doSearch(t));
            };
            const l = this.typeaheadUrl.replace(":search", t);
            s.open("GET", l, !0), s.send();
          } else
            this.doSearch(t);
        }
        this.oldInput = this.input;
      }
    },
    doSearch(e) {
      this.searchResults = [];
      for (let t of this.typeaheadTags) {
        const s = this.caseSensitiveTags ? t[this.textField] : t[this.textField].toLowerCase(), d = this.searchResults.map((l) => l[this.idField]);
        s.search(e) > -1 && !this.tagSelected(t) && !d.includes(t[this.idField]) && this.searchResults.push(t);
      }
      this.sortSearchResults && this.searchResults.sort((t, s) => t[this.textField] < s[this.textField] ? -1 : t[this.textField] > s[this.textField] ? 1 : 0), this.typeaheadMaxResults > 0 && (this.searchResults = this.searchResults.slice(
        0,
        this.typeaheadMaxResults
      ));
    },
    hideTypeahead() {
      this.input.length || this.$nextTick(() => {
        this.clearSearchResults();
      });
    },
    nextSearchResult() {
      this.searchSelection + 1 <= this.searchResults.length - 1 && this.searchSelection++;
    },
    prevSearchResult() {
      this.searchSelection > 0 && this.searchSelection--;
    },
    clearSearchResults(e = !1) {
      this.searchResults = [], this.searchSelection = 0, this.typeaheadAlwaysShow && this.$nextTick(() => {
        this.searchTag();
      }), e && this.$refs.taginput.focus();
    },
    clearTags() {
      this.tags.splice(0, this.tags.length);
    },
    tagsFromValue() {
      if (this.modelValue && this.modelValue.length) {
        if (!Array.isArray(this.modelValue)) {
          console.error(
            "Vue Tags Input: the v-model modelValue must be an array!"
          );
          return;
        }
        let e = this.modelValue;
        if (this.tags == e)
          return;
        this.clearTags();
        for (let t of e)
          this.addTag(t, !0);
      } else {
        if (this.tags.length == 0)
          return;
        this.clearTags();
      }
    },
    tagSelected(e) {
      if (this.allowDuplicates || !e)
        return !1;
      const t = this.escapeRegExp(
        this.caseSensitiveTags ? e[this.textField] : e[this.textField].toLowerCase()
      );
      for (let s of this.tags) {
        const d = this.caseSensitiveTags ? s[this.textField] : s[this.textField].toLowerCase();
        if (s[this.idField] === e[this.idField] && this.escapeRegExp(d).length == t.length && d.search(t) > -1)
          return !0;
      }
      return !1;
    },
    clearInput() {
      this.input = "";
    },
    onKeyUp(e) {
      this.$emit("keyup", e);
    },
    onKeyDown(e) {
      this.$emit("keydown", e);
    },
    onFocus(e) {
      this.$emit("focus", e), this.isActive = !0;
    },
    onClick(e) {
      this.$emit("click", e), this.isActive = !0, this.searchTag();
    },
    onBlur(e) {
      this.$emit("blur", e), this.addTagsOnBlur && this.tagFromInput(!0), this.typeaheadAlwaysShow ? this.searchTag() : this.hideTypeahead(), this.isActive = !1;
    },
    hiddenInputValue(e) {
      if (!this.valueFields)
        return JSON.stringify(e);
      const t = this.valueFields.replace(/\s/, "").split(",");
      return t.length === 1 ? e[t[0]] : JSON.stringify(
        Object.assign({}, ...t.map((s) => ({ [s]: e[s] })))
      );
    },
    getDisplayField(e) {
      return this.displayField !== void 0 && this.displayField !== null && e[this.displayField] !== void 0 && e[this.displayField] !== null && e[this.displayField] !== "" ? e[this.displayField] : e[this.textField];
    },
    cloneArray(e) {
      return e.map((t) => Object.assign({}, t));
    }
  }
}, b = {
  class: "tags-input-root",
  style: { position: "relative" }
}, k = ["innerHTML"], w = ["onClick"], C = ["id", "name", "placeholder", "value"], I = {
  key: 0,
  style: { display: "none" }
}, A = ["name", "value"], B = ["textContent"], O = ["innerHTML", "onMouseover", "onMousedown"], L = ["textContent"], M = ["innerHTML", "onMouseover", "onMousedown"];
function D(e, t, s, d, l, a) {
  return n(), r("div", b, [
    c("div", {
      class: u({
        [s.wrapperClass + " tags-input"]: !0,
        active: l.isActive,
        disabled: s.disabled
      })
    }, [
      (n(!0), r(y, null, f(l.tags, (i, h) => (n(), r("span", {
        key: h,
        class: u(["tags-input-badge tags-input-badge-pill tags-input-badge-selected-default", { disabled: s.disabled }])
      }, [
        F(e.$slots, "selected-tag", {
          tag: i,
          index: h,
          removeTag: a.removeTag
        }, () => [
          c("span", {
            innerHTML: i[s.textField]
          }, null, 8, k),
          S(c("a", {
            href: "#",
            class: "tags-input-remove",
            onClick: o((p) => a.removeTag(h), ["prevent"])
          }, null, 8, w), [
            [T, !s.disabled]
          ])
        ])
      ], 2))), 128)),
      S(c("input", {
        type: "text",
        ref: "taginput",
        id: s.inputId,
        name: s.inputId,
        placeholder: s.placeholder,
        value: l.input,
        onInput: t[0] || (t[0] = (i) => l.input = i.target.value),
        onCompositionstart: t[1] || (t[1] = (i) => l.composing = !0),
        onCompositionend: t[2] || (t[2] = (i) => l.composing = !1),
        onKeydown: [
          t[3] || (t[3] = g(o((i) => a.tagFromInput(!1), ["prevent"]), ["enter"])),
          t[4] || (t[4] = g((...i) => a.removeLastTag && a.removeLastTag(...i), ["delete"])),
          t[5] || (t[5] = g((...i) => a.nextSearchResult && a.nextSearchResult(...i), ["down"])),
          t[6] || (t[6] = g((...i) => a.prevSearchResult && a.prevSearchResult(...i), ["up"])),
          t[7] || (t[7] = (...i) => a.onKeyDown && a.onKeyDown(...i))
        ],
        onKeyup: [
          t[8] || (t[8] = (...i) => a.onKeyUp && a.onKeyUp(...i)),
          t[9] || (t[9] = g((...i) => a.clearSearchResults && a.clearSearchResults(...i), ["esc"]))
        ],
        onFocus: t[10] || (t[10] = (...i) => a.onFocus && a.onFocus(...i)),
        onClick: t[11] || (t[11] = (...i) => a.onClick && a.onClick(...i)),
        onBlur: t[12] || (t[12] = (...i) => a.onBlur && a.onBlur(...i)),
        onValue: t[13] || (t[13] = (...i) => l.tags && l.tags(...i))
      }, null, 40, C), [
        [T, !a.hideInputField]
      ]),
      s.elementId ? (n(), r("div", I, [
        (n(!0), r(y, null, f(l.tags, (i, h) => (n(), r("input", {
          key: h,
          type: "hidden",
          name: `${s.elementId}[]`,
          value: a.hiddenInputValue(i)
        }, null, 8, A))), 128))
      ])) : m("", !0)
    ], 2),
    S(c("div", null, [
      s.typeaheadStyle === "badges" ? (n(), r("p", {
        key: 0,
        class: u(`typeahead-${s.typeaheadStyle}`)
      }, [
        s.typeaheadHideDiscard ? m("", !0) : (n(), r("span", {
          key: 0,
          class: "tags-input-badge typeahead-hide-btn tags-input-typeahead-item-default",
          onClick: t[14] || (t[14] = o((i) => a.clearSearchResults(!0), ["prevent"])),
          textContent: v(s.discardSearchText)
        }, null, 8, B)),
        (n(!0), r(y, null, f(l.searchResults, (i, h) => (n(), r("span", {
          key: h,
          innerHTML: i[s.textField],
          onMouseover: (p) => l.searchSelection = h,
          onMousedown: o((p) => a.tagFromSearchOnClick(i), ["prevent"]),
          class: u(["tags-input-badge", {
            "tags-input-typeahead-item-default": h != l.searchSelection,
            "tags-input-typeahead-item-highlighted-default": h == l.searchSelection
          }])
        }, null, 42, O))), 128))
      ], 2)) : s.typeaheadStyle === "dropdown" ? (n(), r("ul", {
        key: 1,
        class: u(`typeahead-${s.typeaheadStyle}`)
      }, [
        s.typeaheadHideDiscard ? m("", !0) : (n(), r("li", {
          key: 0,
          class: "tags-input-typeahead-item-default typeahead-hide-btn",
          onClick: t[15] || (t[15] = o((i) => a.clearSearchResults(!0), ["prevent"])),
          textContent: v(s.discardSearchText)
        }, null, 8, L)),
        (n(!0), r(y, null, f(l.searchResults, (i, h) => (n(), r("li", {
          key: h,
          innerHTML: a.getDisplayField(i),
          onMouseover: (p) => l.searchSelection = h,
          onMousedown: o((p) => a.tagFromSearchOnClick(i), ["prevent"]),
          class: u({
            "tags-input-typeahead-item-default": h != l.searchSelection,
            "tags-input-typeahead-item-highlighted-default": h == l.searchSelection
          })
        }, null, 42, M))), 128))
      ], 2)) : m("", !0)
    ], 512), [
      [T, l.searchResults.length]
    ])
  ]);
}
const E = /* @__PURE__ */ x(R, [["render", D]]);
window.VueTagsInput = E;
export {
  E as default
};
